Package groovy.lang

# Class MetaClassImpl

java.lang.Object
groovy.lang.MetaClassImpl

All Implemented Interfaces:
  `MetaClass`, `MetaObjectProtocol`, `MutableMetaClass`

Direct Known Subclasses:
  `ClosureMetaClass`, `ExpandoMetaClass`, `PackedClosureMetaClass`, `ProxyMetaClass`

public class MetaClassImpl extends Object implements MetaClass, MutableMetaClass
Allows methods to be dynamically added to existing classes at runtime

See Also:
  - `MetaClass`

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `MetaClassImpl.MetaConstructor`
  This is a helper class which is used only by indy.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Object[]`
  `EMPTY_ARGUMENTS`
  Shared empty argument array used by MOP dispatch helpers.
  `protected MetaMethod`
  `getPropertyMethod`
  Effective `getProperty` handler discovered for this meta class.
  `protected static final String`
  `INVOKE_METHOD_METHOD`
  Conventional Groovy instance `invokeMethod` hook name.
  `protected MetaMethod`
  `invokeMethodMethod`
  Effective `invokeMethod` handler discovered for this meta class.
  `protected final boolean`
  `isGroovyObject`
  Indicates whether `theClass` implements `GroovyObject`.
  `protected final boolean`
  `isMap`
  Indicates whether `theClass` is assignable from `Map`.
  `protected final MetaMethodIndex`
  `metaMethodIndex`
  Method index used for Groovy method selection and caching.
  `protected static final String`
  `METHOD_MISSING`
  Conventional Groovy instance `methodMissing` hook name.
  `protected static final String`
  `PROPERTY_MISSING`
  Conventional Groovy instance `propertyMissing` hook name.
  `protected MetaClassRegistry`
  `registry`
  Registry that owns this meta class.
  `protected MetaMethod`
  `setPropertyMethod`
  Effective `setProperty` handler discovered for this meta class.
  `protected static final String`
  `STATIC_METHOD_MISSING`
  Synthetic method name used for static `methodMissing` dispatch.
  `protected static final String`
  `STATIC_PROPERTY_MISSING`
  Synthetic method name used for static `propertyMissing` dispatch.
  `protected final CachedClass`
  `theCachedClass`
  Cached reflection view for `theClass`.
  `protected final Class`
  `theClass`
  Java class represented by this meta class.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MetaClassImpl(MetaClassRegistry registry, Class theClass)`
  Constructor with registry setting methods to null
  `MetaClassImpl(MetaClassRegistry registry, Class theClass, MetaMethod[] add)`
  Constructor with registry
  `MetaClassImpl(Class theClass)`
  Constructor that sets the methods to null
  `MetaClassImpl(Class theClass, MetaMethod[] add)`
  Constructor

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addMetaBeanProperty(MetaBeanProperty mp)`
  Adds a new MetaBeanProperty to this MetaClass.
  `void`
  `addMetaMethod(MetaMethod method)`
  Adds a MetaMethod to this class.
  `protected void`
  `addMetaMethodToIndex(MetaMethod method, Map<String,MetaMethodIndex.Cache> cacheIndex)`
  Adds a meta method to the supplied method index after standard-hook bookkeeping.
  `void`
  `addNewInstanceMethod(Method method)`
  Adds an instance method to this metaclass.
  `void`
  `addNewStaticMethod(Method method)`
  Adds a static method to this metaclass.
  `protected void`
  `applyPropertyDescriptors(PropertyDescriptor[] propertyDescriptors)`
  Turns JavaBeans property descriptors into Groovy meta properties.
  `protected final void`
  `checkIfGroovyObjectMethod(MetaMethod metaMethod)`
  Checks if the metaMethod is getProperty, setProperty, or invokeMethod.
  `protected void`
  `checkInitalised()`
  checks if the initialisation of the class id complete.
  `CachedConstructor`
  `chooseConstructor(Class<?>[] argTypes)`
  Selects a constructor matching the given parameter types.
  `protected Object`
  `chooseMethod(String methodName, Object methodOrList, Class[] arguments)`
  Chooses the correct method to use from a list of methods which match by name.
  `Object`
  `chooseNamedArgCompatibleConstructor(Class<?>[] argTypes, Object[] args)`
  Selects a no-arg (or outer-instance) constructor used for named-argument construction, after a direct map-style match has already failed.
  `protected void`
  `clearInvocationCaches()`
  remove all method call cache entries.
  `protected static String`
  `createErrorMessageForAmbiguity(String theClassName, String name, Class[] arguments, LinkedList matches)`
  Creates the diagnostic message for an ambiguous overload selection.
  `protected MetaMethod`
  `createTransformMetaMethod(MetaMethod method)`
  Wraps a meta method so single-list arguments are expanded before invocation.
  `protected static Object`
  `doChooseMostSpecificParams(String theClassName, String name, List matchingMethods, Class[] arguments, boolean checkParameterCompatibility)`
  Chooses the most specific overload among matching parameter type candidates.
  `protected void`
  `dropMethodCache(String name)`
  Clears cached instance method selections for the supplied method name.
  `protected void`
  `dropStaticMethodCache(String name)`
  Clears cached static method selections for the supplied method name.
  `protected static MetaMethod`
  `findMethodInClassHierarchy(Class instanceKlazz, String methodName, Class[] arguments, MetaClass metaClass)`
  Searches a meta-class hierarchy for the most specific visible method on the missing-method path.
  `protected MetaMethod`
  `findMixinMethod(String methodName, Class[] arguments)`
  Searches for a matching mixin method.
  `protected static MetaMethod`
  `findOwnMethod(Class instanceKlazz, String methodName, Class[] arguments, MetaClass metaClass, MetaMethod method)`
  Chooses the best method declared directly on the supplied meta class.
  `protected MetaBeanProperty`
  `findPropertyInClassHierarchy(String propertyName, CachedClass theClass)`
  Searches the class hierarchy for a mutable meta-class bean property on the missing-property path.
  `MetaMethod[]`
  `getAdditionalMetaMethods()`
  Retrieves a list of additional MetaMethods held by this class
  `Object`
  `getAttribute(Class sender, Object object, String attribute, boolean useSuper)`
  Retrieves the value of an attribute (field).
  `Object`
  `getAttribute(Class sender, Object object, String attribute, boolean useSuper, boolean fromInsideClass)`
  Retrieves the value of an attribute (field).
  `Object`
  `getAttribute(Object object, String attribute)`
  Retrieves the value of an attribute (field).
  `ClassInfo`
  `getClassInfo()`
  Returns the ClassInfo for the contained Class
  `ClassNode`
  `getClassNode()`
  Obtains a reference to the original AST for the MetaClass if it is available at runtime
  `MetaProperty`
  `getEffectiveGetMetaProperty(Class sender, Object object, String name, boolean useSuper)`
  Returns the effective readable meta property for a property access.
  `MetaMethod`
  `getMetaMethod(String name, Object[] argTypes)`
  Retrieves an instance MetaMethod for the given name and argument values, using the types of the argument values to establish the chosen MetaMethod
  `List<MetaMethod>`
  `getMetaMethods()`
  Retrieves the list of MetaMethods held by this class.
  `MetaProperty`
  `getMetaProperty(String name)`
  Returns a MetaProperty for the given name or null if it doesn't exist
  `List<MetaMethod>`
  `getMethods()`
  Retrieves the list of MetaMethods held by the class.
  `MetaMethod`
  `getMethodWithCaching(Class sender, String methodName, Class<?>[] params)`
  Selects a method using pre-converted parameter types and the call-site style method cache (keyed by `Class[]`).
  `MetaMethod`
  `getMethodWithCaching(Class sender, String methodName, Object[] arguments, boolean isCallToSuper)`
  Resolves a method and caches the selection for the supplied argument types.
  `MetaMethod`
  `getMethodWithoutCaching(Class sender, String methodName, Class[] arguments, boolean isCallToSuper)`
  Resolves a method without populating the method cache.
  `protected static Class<?>`
  `getNonClosureOuter(Class<?> c)`
  `List<MetaProperty>`
  `getProperties()`
  Returns the available properties for this type.
  `Object`
  `getProperty(Class sender, Object object, String name, boolean useSuper, boolean fromInsideClass)`
  Retrieves a property on the given receiver for the specified arguments.
  `Object`
  `getProperty(Object object, String property)`
  Retrieves a property on the given object for the specified arguments.
  `MetaClassRegistry`
  `getRegistry()`
  Returns the registry for this metaclass
  `MetaMethod`
  `getStaticMetaMethod(String name, Object[] argTypes)`
  Retrieves a static MetaMethod for the given name and argument values, using the types of the arguments to establish the chosen MetaMethod
  `protected Object`
  `getSubclassMetaMethods(String methodName)`
  Returns subclass-scoped meta methods contributed by specialized meta classes.
  `protected LinkedList<CachedClass>`
  `getSuperClasses()`
  Returns the cached super-class chain used while building method and property indexes.
  `final CachedClass`
  `getTheCachedClass()`
  Returns the cached class for this metaclass
  `Class`
  `getTheClass()`
  Returns the class this metaclass represents.
  `int`
  `getVersion()`
  Returns version of the contained Class
  `protected static long`
  `handleMatches(long matchesDistance, LinkedList matches, Object method, long dist)`
  Updates the current best-match set using the supplied distance metric.
  `boolean`
  `hasCustomInvokeMethod()`
  indicates is the metaclass method invocation for non-static methods is done through a custom invoker object.
  `boolean`
  `hasCustomStaticInvokeMethod()`
  indicates is the metaclass method invocation for static methods is done through a custom invoker object.
  `MetaProperty`
  `hasProperty(Object obj, String name)`
  Returns true of the implementing MetaClass has a property of the given name
  `void`
  `incVersion()`
  Increments version of the contained Class
  `void`
  `initialize()`
  Complete the initialisation process.
  `Object`
  `invokeConstructor(Object[] arguments)`
  Invokes a constructor for the given arguments.
  `Object`
  `invokeMethod(Class sender, Object object, String methodName, Object[] originalArguments, boolean isCallToSuper, boolean fromInsideClass)`
  Invokes a method on the given receiver for the specified arguments.
  `Object`
  `invokeMethod(Object object, String methodName, Object arguments)`
  Invoke a method on the given object with the given arguments.
  `Object`
  `invokeMethod(Object object, String methodName, Object[] arguments)`
  Invokes a method on the given receiver for the specified arguments.
  `Object`
  `invokeMissingMethod(Object instance, String methodName, Object[] arguments)`
  Invoke a missing method on the given object with the given arguments.
  `Object`
  `invokeMissingProperty(Object instance, String propertyName, Object optionalValue, boolean isGetter)`
  Invoke a missing property on the given object with the given arguments.
  `Object`
  `invokeStaticMethod(Object object, String methodName, Object[] arguments)`
  Invokes a static method on the given Object with the given name and arguments.
  `protected Object`
  `invokeStaticMissingProperty(Object instance, String propertyName, Object optionalValue, boolean isGetter)`
  Hook to deal with the case of missing property for static properties.
  `boolean`
  `isGroovyObject()`
  Indicates if the represented class is an instance of the `GroovyObject` class.
  `protected boolean`
  `isInitialized()`
  Indicates whether this meta class finished initialization.
  `boolean`
  `isModified()`
  Returns whether this MetaClassImpl has been modified.
  `boolean`
  `isPermissivePropertyAccess()`
  Indicates whether permissive property access semantics are enabled.
  `protected void`
  `onGetPropertyFoundInHierarchy(MetaMethod method)`
  Callback invoked when a `getProperty` implementation is discovered.
  `protected void`
  `onInvokeMethodFoundInHierarchy(MetaMethod method)`
  Callback invoked when an `invokeMethod` implementation is discovered.
  `protected void`
  `onMixinMethodFound(MetaMethod method)`
  Callback invoked when a mixin method is discovered during initialization.
  `protected void`
  `onSetPropertyFoundInHierarchy(MetaMethod method)`
  Callback invoked when a `setProperty` implementation is discovered.
  `protected void`
  `onSuperMethodFoundInHierarchy(MetaMethod method)`
  Callback invoked when a super-class method is discovered during initialization.
  `protected void`
  `onSuperPropertyFoundInHierarchy(MetaBeanProperty property)`
  Callback invoked when a super-class bean property is discovered during initialization.
  `MetaMethod`
  `pickMethod(String methodName, Class[] arguments)`
  Selects a method by name and argument classes.
  `protected void`
  `reinitialize()`
  Rebuilds method, property and call-site state for this meta class.
  `List<MetaMethod>`
  `respondsTo(Object obj, String name)`
  Returns an object satisfying Groovy truth if the implementing MetaClass responds to a method with the given name regardless of arguments.
  `List<MetaMethod>`
  `respondsTo(Object obj, String name, Object[] argTypes)`
  Returns an object satisfying Groovy truth if the implementing MetaClass responds to a method with the given name and arguments types.
  `Constructor`
  `retrieveConstructor(Class[] arguments)`
  Resolves a constructor by parameter types.
  `MetaMethod`
  `retrieveConstructor(Object[] arguments)`
  This is a helper method which is used only by indy.
  `MetaMethod`
  `retrieveStaticMethod(String methodName, Object[] arguments)`
  Resolves a static method and caches the selection when possible.
  `int`
  `selectConstructorAndTransformArguments(int numberOfConstructors, Object[] arguments)`
  Internal method to support Groovy runtime.
  `void`
  `setAttribute(Class sender, Object object, String attribute, Object newValue, boolean useSuper, boolean fromInsideClass)`
  Sets an attribute on the given receiver for the specified arguments.
  `void`
  `setAttribute(Object object, String attribute, Object newValue)`
  Sets the value of an attribute (field).
  `protected void`
  `setInitialized(boolean initialized)`
  Updates the initialization flag for this meta class.
  `void`
  `setPermissivePropertyAccess(boolean permissivePropertyAccess)`
  Enables or disables permissive property access semantics.
  `void`
  `setProperties(Object bean, Map map)`
  Sets a number of bean properties from the given Map where the keys are the String names of properties and the values are the values of the properties to set
  `void`
  `setProperty(Class sender, Object object, String name, Object newValue, boolean useSuper, boolean fromInsideClass)`
  Writes a property on the given receiver for the specified arguments.
  `void`
  `setProperty(Object object, String property, Object newValue)`
  Sets a property on the given object for the specified arguments.
  `String`
  `toString()`
  Returns a string representation of this metaclass

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### EMPTY_ARGUMENTS

    public static final Object[] EMPTY_ARGUMENTS
    Shared empty argument array used by MOP dispatch helpers.

  - ### STATIC_METHOD_MISSING

    protected static final String STATIC_METHOD_MISSING
    Synthetic method name used for static `methodMissing` dispatch.
    See Also:
      - Constant Field Values

  - ### STATIC_PROPERTY_MISSING

    protected static final String STATIC_PROPERTY_MISSING
    Synthetic method name used for static `propertyMissing` dispatch.
    See Also:
      - Constant Field Values

  - ### METHOD_MISSING

    protected static final String METHOD_MISSING
    Conventional Groovy instance `methodMissing` hook name.
    See Also:
      - Constant Field Values

  - ### PROPERTY_MISSING

    protected static final String PROPERTY_MISSING
    Conventional Groovy instance `propertyMissing` hook name.
    See Also:
      - Constant Field Values

  - ### INVOKE_METHOD_METHOD

    protected static final String INVOKE_METHOD_METHOD
    Conventional Groovy instance `invokeMethod` hook name.
    See Also:
      - Constant Field Values

  - ### theClass

    protected final Class theClass
    Java class represented by this meta class.

  - ### theCachedClass

    protected final CachedClass theCachedClass
    Cached reflection view for `theClass`.

  - ### isGroovyObject

    protected final boolean isGroovyObject
    Indicates whether `theClass` implements `GroovyObject`.

  - ### isMap

    protected final boolean isMap
    Indicates whether `theClass` is assignable from `Map`.

  - ### metaMethodIndex

    protected final MetaMethodIndex metaMethodIndex
    Method index used for Groovy method selection and caching.

  - ### getPropertyMethod

    protected MetaMethod getPropertyMethod
    Effective `getProperty` handler discovered for this meta class.

  - ### invokeMethodMethod

    protected MetaMethod invokeMethodMethod
    Effective `invokeMethod` handler discovered for this meta class.

  - ### setPropertyMethod

    protected MetaMethod setPropertyMethod
    Effective `setProperty` handler discovered for this meta class.

  - ### registry

    protected MetaClassRegistry registry
    Registry that owns this meta class.

- ## Constructor Details

  - ### MetaClassImpl

    public MetaClassImpl(Class theClass, MetaMethod[] add)
    Constructor
    Parameters:
      `theClass` - The class this is the metaclass for
      `add` - The methods for this class

  - ### MetaClassImpl

    public MetaClassImpl(Class theClass)
    Constructor that sets the methods to null
    Parameters:
      `theClass` - The class this is the metaclass for

  - ### MetaClassImpl

    public MetaClassImpl(MetaClassRegistry registry, Class theClass, MetaMethod[] add)
    Constructor with registry
    Parameters:
      `registry` - The metaclass registry for this MetaClass
      `theClass` - The class
      `add` - The methods

  - ### MetaClassImpl

    public MetaClassImpl(MetaClassRegistry registry, Class theClass)
    Constructor with registry setting methods to null
    Parameters:
      `registry` - The metaclass registry for this MetaClass
      `theClass` - The class

- ## Method Details

  - ### getTheCachedClass

    public final CachedClass getTheCachedClass()
    Returns the cached class for this metaclass
    Returns:
      The cached class.

  - ### getRegistry

    public MetaClassRegistry getRegistry()
    Returns the registry for this metaclass
    Returns:
      The registry

  - ### respondsTo

    public List<MetaMethod> respondsTo(Object obj, String name, Object[] argTypes)
    Description copied from interface: `MetaObjectProtocol`

    Returns an object satisfying Groovy truth if the implementing MetaClass responds to a method with the given name and arguments types.

    Note that this method's return value is based on realised methods and does not take into account objects or classes that implement invokeMethod or methodMissing

    This method is "safe" in that it will always return a value and never throw an exception

    Specified by:
      `respondsTo` in interface `MetaObjectProtocol`
    Parameters:
      `obj` - The object to inspect
      `name` - The name of the method of interest
      `argTypes` - The argument types to match against
    Returns:
      A List of MetaMethods matching the argument types which will be empty if no matching methods exist
    See Also:
      - `MetaObjectProtocol.respondsTo(Object, String, Object[])`

  - ### respondsTo

    public List<MetaMethod> respondsTo(Object obj, String name)
    Description copied from interface: `MetaObjectProtocol`

    Returns an object satisfying Groovy truth if the implementing MetaClass responds to a method with the given name regardless of arguments. In other words this method will return for foo() and foo(String).

    Note that this method's return value is based on realised methods and does not take into account objects or classes that implement invokeMethod or methodMissing

    This method is "safe" in that it will always return a value and never throw an exception

    Specified by:
      `respondsTo` in interface `MetaObjectProtocol`
    Parameters:
      `obj` - The object to inspect
      `name` - The name of the method of interest
    Returns:
      A List of MetaMethods which will be empty if no methods with the given name exist
    See Also:
      - `MetaObjectProtocol.respondsTo(Object, String)`

  - ### hasProperty

    public MetaProperty hasProperty(Object obj, String name)
    Description copied from interface: `MetaObjectProtocol`

    Returns true of the implementing MetaClass has a property of the given name

    Note that this method will only return true for realised properties and does not take into account implementation of getProperty or propertyMissing

    Specified by:
      `hasProperty` in interface `MetaObjectProtocol`
    Parameters:
      `obj` - The object to inspect
      `name` - The name of the property
    Returns:
      The MetaProperty or null if it doesn't exist
    See Also:
      - `MetaObjectProtocol.hasProperty(Object, String)`

  - ### getMetaProperty

    public MetaProperty getMetaProperty(String name)
    Description copied from interface: `MetaObjectProtocol`
    Returns a MetaProperty for the given name or null if it doesn't exist
    Specified by:
      `getMetaProperty` in interface `MetaObjectProtocol`
    Parameters:
      `name` - The name of the MetaProperty
    Returns:
      A MetaProperty or null
    See Also:
      - `MetaObjectProtocol.getMetaProperty(String)`

  - ### getStaticMetaMethod

    public MetaMethod getStaticMetaMethod(String name, Object[] argTypes)
    Description copied from interface: `MetaObjectProtocol`
    Retrieves a static MetaMethod for the given name and argument values, using the types of the arguments to establish the chosen MetaMethod
    Specified by:
      `getStaticMetaMethod` in interface `MetaObjectProtocol`
    Parameters:
      `name` - The name of the MetaMethod
      `argTypes` - The argument types
    Returns:
      A MetaMethod or null if it doesn't exist
    See Also:
      - `MetaObjectProtocol.getStaticMetaMethod(String, Object[])`

  - ### getMetaMethod

    public MetaMethod getMetaMethod(String name, Object[] argTypes)
    Description copied from interface: `MetaObjectProtocol`
    Retrieves an instance MetaMethod for the given name and argument values, using the types of the argument values to establish the chosen MetaMethod
    Specified by:
      `getMetaMethod` in interface `MetaObjectProtocol`
    Parameters:
      `name` - The name of the MetaMethod
      `argTypes` - Array containing - 1) the argument values (using which their types are then inferred), or 2) the corresponding argument types
    Returns:
      A MetaMethod or null if it doesn't exist
    See Also:
      - `MetaObjectProtocol.getMetaMethod(String, Object[])`

  - ### getTheClass

    public Class getTheClass()
    Returns the class this metaclass represents.
    Specified by:
      `getTheClass` in interface `MetaObjectProtocol`
    Returns:
      The java.lang.Class instance

  - ### isGroovyObject

    public boolean isGroovyObject()
    Indicates if the represented class is an instance of the `GroovyObject` class.

  - ### getSuperClasses

    protected LinkedList<CachedClass> getSuperClasses()
    Returns the cached super-class chain used while building method and property indexes.
    Returns:
      the cached super classes in lookup order

  - ### isModified

    public boolean isModified()
    Returns whether this MetaClassImpl has been modified. Since MetaClassImpl is not designed for modification this method always returns false
    Specified by:
      `isModified` in interface `MutableMetaClass`
    Returns:
      false

  - ### addNewInstanceMethod

    public void addNewInstanceMethod(Method method)
    Adds an instance method to this metaclass. Must not be called after initialization: call-site caches are never told about the change, so the method could remain invisible to already-linked call sites.
    Specified by:
      `addNewInstanceMethod` in interface `MutableMetaClass`
    Parameters:
      `method` - The method to be added
    Throws:
      `RuntimeException` - if this metaclass is already initialized

  - ### addNewStaticMethod

    public void addNewStaticMethod(Method method)
    Adds a static method to this metaclass. Must not be called after initialization: call-site caches are never told about the change, so the method could remain invisible to already-linked call sites.
    Specified by:
      `addNewStaticMethod` in interface `MutableMetaClass`
    Parameters:
      `method` - The method to be added
    Throws:
      `RuntimeException` - if this metaclass is already initialized

  - ### invokeMethod

    public Object invokeMethod(Object object, String methodName, Object arguments)
    Invoke a method on the given object with the given arguments.
    Specified by:
      `invokeMethod` in interface `MetaObjectProtocol`
    Parameters:
      `object` - The object the method should be invoked on.
      `methodName` - The name of the method to invoke.
      `arguments` - The arguments to the invoked method as null, a Tuple, an array or a single argument of any type.
    Returns:
      The result of the method invocation.
    See Also:
      - `MetaObjectProtocol.invokeMethod(Object, String, Object[])`

  - ### invokeMissingMethod

    public Object invokeMissingMethod(Object instance, String methodName, Object[] arguments)
    Invoke a missing method on the given object with the given arguments.
    Specified by:
      `invokeMissingMethod` in interface `MetaClass`
    Parameters:
      `instance` - The object the method should be invoked on.
      `methodName` - The name of the method to invoke.
      `arguments` - The arguments to the invoked method.
    Returns:
      The result of the method invocation.
    See Also:
      - `MissingMethodException`

  - ### invokeMissingProperty

    public Object invokeMissingProperty(Object instance, String propertyName, Object optionalValue, boolean isGetter)
    Invoke a missing property on the given object with the given arguments.
    Specified by:
      `invokeMissingProperty` in interface `MetaClass`
    Parameters:
      `instance` - The object the method should be invoked on.
      `propertyName` - The name of the property to invoke.
      `optionalValue` - The (optional) new value for the property
      `isGetter` - Whether the method is a getter
    Returns:
      The result of the method invocation.

  - ### onSuperPropertyFoundInHierarchy

    protected void onSuperPropertyFoundInHierarchy(MetaBeanProperty property)
    Callback invoked when a super-class bean property is discovered during initialization.
    Parameters:
      `property` - the inherited property

  - ### onMixinMethodFound

    protected void onMixinMethodFound(MetaMethod method)
    Callback invoked when a mixin method is discovered during initialization.
    Parameters:
      `method` - the discovered mixin method

  - ### onSuperMethodFoundInHierarchy

    protected void onSuperMethodFoundInHierarchy(MetaMethod method)
    Callback invoked when a super-class method is discovered during initialization.
    Parameters:
      `method` - the inherited method

  - ### onInvokeMethodFoundInHierarchy

    protected void onInvokeMethodFoundInHierarchy(MetaMethod method)
    Callback invoked when an `invokeMethod` implementation is discovered.
    Parameters:
      `method` - the discovered handler

  - ### onSetPropertyFoundInHierarchy

    protected void onSetPropertyFoundInHierarchy(MetaMethod method)
    Callback invoked when a `setProperty` implementation is discovered.
    Parameters:
      `method` - the discovered handler

  - ### onGetPropertyFoundInHierarchy

    protected void onGetPropertyFoundInHierarchy(MetaMethod method)
    Callback invoked when a `getProperty` implementation is discovered.
    Parameters:
      `method` - the discovered handler

  - ### invokeStaticMissingProperty

    protected Object invokeStaticMissingProperty(Object instance, String propertyName, Object optionalValue, boolean isGetter)
    Hook to deal with the case of missing property for static properties. The method attempts to look up "$static_propertyMissing" handlers and invoke them otherwise throws a MissingPropertyException.
    Parameters:
      `instance` - the class instance
      `propertyName` - the name of the property
      `optionalValue` - the value in the case of a setter
      `isGetter` - true for property read, false for property write
    Returns:
      The value in the case of a getter or null in the case of a setter.
    Throws:
      `MissingPropertyException`

  - ### invokeMethod

    public Object invokeMethod(Object object, String methodName, Object[] arguments)
    Invokes a method on the given receiver for the specified arguments. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided.
    Specified by:
      `invokeMethod` in interface `MetaObjectProtocol`
    Parameters:
      `object` - The object which the method was invoked on
      `methodName` - The name of the method
      `arguments` - The arguments to the method
    Returns:
      The return value of the method
    See Also:
      - `MetaClass.invokeMethod(Class, Object, String, Object[], boolean, boolean)`

  - ### invokeMethod

    public Object invokeMethod(Class sender, Object object, String methodName, Object[] originalArguments, boolean isCallToSuper, boolean fromInsideClass)
    Invokes a method on the given receiver for the specified arguments. The sender is the class that invoked the method on the object. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided.

    The isCallToSuper and fromInsideClass help the Groovy runtime perform optimisations on the call to go directly to the super class if necessary

    Specified by:
      `invokeMethod` in interface `MetaClass`
    Parameters:
      `sender` - The java.lang.Class instance that invoked the method
      `object` - The object which the method was invoked on
      `methodName` - The name of the method
      `originalArguments` - The arguments to the method
      `isCallToSuper` - Whether the method is a call to a super class method
      `fromInsideClass` - Whether the call was invoked from the inside or the outside of the class
    Returns:
      The return value of the method.
    See Also:
      - `MetaClass.invokeMethod(Class, Object, String, Object[], boolean, boolean)`

  - ### getNonClosureOuter

    protected static Class<?> getNonClosureOuter(Class<?> c)
    Since:
      6.0.0

  - ### createTransformMetaMethod

    protected MetaMethod createTransformMetaMethod(MetaMethod method)
    Wraps a meta method so single-list arguments are expanded before invocation.
    Parameters:
      `method` - the method to wrap
    Returns:
      the transforming method, or `null` if the input method is `null`

  - ### getMethodWithCaching

    public MetaMethod getMethodWithCaching(Class sender, String methodName, Object[] arguments, boolean isCallToSuper)
    Resolves a method and caches the selection for the supplied argument types.
    Parameters:
      `sender` - the calling class
      `methodName` - the method name
      `arguments` - the runtime arguments
      `isCallToSuper` - whether the dispatch originated from `super`
    Returns:
      the selected meta method, or `null` if none matches

  - ### getMethodWithCaching

    public MetaMethod getMethodWithCaching(Class sender, String methodName, Class<?>[] params)
    Selects a method using pre-converted parameter types and the call-site style method cache (keyed by `Class[]`).

    Prefer `getMethodWithCaching(Class, String, Object[], boolean)` when only runtime argument values are available. This overload exists so optional runtime modules (e.g. classic call-site dispatch) can share the same selection path without depending on package-private state.

    Parameters:
      `sender` - the class whose meta-method index is consulted
      `methodName` - the method name
      `params` - the argument types (must not be `null`)
    Returns:
      the selected meta method, or `null` if none matches
    Since:
      6.0.0

  - ### chooseConstructor

    public CachedConstructor chooseConstructor(Class<?>[] argTypes)
    Selects a constructor matching the given parameter types.
    Parameters:
      `argTypes` - the constructor argument types
    Returns:
      the matching cached constructor, or `null`
    Since:
      6.0.0

  - ### chooseNamedArgCompatibleConstructor

    public Object chooseNamedArgCompatibleConstructor(Class<?>[] argTypes, Object[] args)
    Selects a no-arg (or outer-instance) constructor used for named-argument construction, after a direct map-style match has already failed.
    Parameters:
      `argTypes` - the original argument types including the trailing map
      `args` - the original arguments including the trailing map
    Returns:
      the matching constructor as a `CachedConstructor`, or another `ParameterTypes` result from method selection
    Since:
      6.0.0

  - ### retrieveConstructor

    public Constructor retrieveConstructor(Class[] arguments)
    Resolves a constructor by parameter types.
    Parameters:
      `arguments` - the constructor parameter types
    Returns:
      the matching constructor, or `null` if none matches

  - ### getMethodWithoutCaching

    public MetaMethod getMethodWithoutCaching(Class sender, String methodName, Class[] arguments, boolean isCallToSuper)
    Resolves a method without populating the method cache.
    Parameters:
      `sender` - the calling class
      `methodName` - the method name
      `arguments` - the parameter types
      `isCallToSuper` - whether the dispatch originated from `super`
    Returns:
      the selected meta method, or `null` if none matches

  - ### retrieveStaticMethod

    public MetaMethod retrieveStaticMethod(String methodName, Object[] arguments)
    Resolves a static method and caches the selection when possible.
    Parameters:
      `methodName` - the method name
      `arguments` - the runtime arguments
    Returns:
      the selected static meta method, or `null` if none matches

  - ### invokeStaticMethod

    public Object invokeStaticMethod(Object object, String methodName, Object[] arguments)
    Invokes a static method on the given Object with the given name and arguments.

    The Object can either be an instance of the class that this MetaObjectProtocol instance applies to or the java.lang.Class instance itself. If a method cannot be invoked a MissingMethodException is will be thrown

    Specified by:
      `invokeStaticMethod` in interface `MetaObjectProtocol`
    Parameters:
      `object` - An instance of the class returned by the getTheClass() method or the class itself
      `methodName` - The name of the method
      `arguments` - The arguments to the method
    Returns:
      The return value of the method which is null if the return type is void
    See Also:
      - `MissingMethodException`

  - ### invokeConstructor

    public Object invokeConstructor(Object[] arguments)
    Invokes a constructor for the given arguments. The MetaClass will attempt to pick the best argument which matches the types of the objects passed within the arguments array
    Specified by:
      `invokeConstructor` in interface `MetaObjectProtocol`
    Parameters:
      `arguments` - The arguments to the constructor
    Returns:
      An instance of the java.lang.Class that this MetaObjectProtocol object applies to

  - ### selectConstructorAndTransformArguments

    public int selectConstructorAndTransformArguments(int numberOfConstructors, Object[] arguments)
    Internal method to support Groovy runtime. Not for client usage.
    Specified by:
      `selectConstructorAndTransformArguments` in interface `MetaClass`
    Parameters:
      `numberOfConstructors` - The number of constructors
      `arguments` - The arguments
    Returns:
      selected index

  - ### checkInitalised

    protected void checkInitalised()
    checks if the initialisation of the class id complete. This method should be called as a form of assert, it is no way to test if there is still initialisation work to be done. Such logic must be implemented in a different way.
    Throws:
      `IllegalStateException` - if the initialisation is incomplete yet

  - ### retrieveConstructor

    public MetaMethod retrieveConstructor(Object[] arguments)
    This is a helper method which is used only by indy. It is for internal use.
    Since:
      2.1.0

  - ### setProperties

    public void setProperties(Object bean, Map map)
    Sets a number of bean properties from the given Map where the keys are the String names of properties and the values are the values of the properties to set

  - ### getProperty

    public Object getProperty(Class sender, Object object, String name, boolean useSuper, boolean fromInsideClass)

    Retrieves a property on the given receiver for the specified arguments. The sender is the class that is requesting the property from the object. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided.

    The isCallToSuper and fromInsideClass help the Groovy runtime perform optimisations on the call to go directly to the super class if necessary

    Specified by:
      `getProperty` in interface `MetaClass`
    Parameters:
      `sender` - The java.lang.Class instance that requested the property
      `object` - The Object which the property is being retrieved from
      `name` - The name of the property
      `useSuper` - Whether the call is to a super class property
      `fromInsideClass` - ??
    Returns:
      The property's value.

  - ### getEffectiveGetMetaProperty

    public MetaProperty getEffectiveGetMetaProperty(Class sender, Object object, String name, boolean useSuper)
    Returns the effective readable meta property for a property access.
    Parameters:
      `sender` - the calling class
      `object` - the receiver object or class
      `name` - the property name
      `useSuper` - whether the lookup should start at the super class
    Returns:
      the effective readable meta property

  - ### getProperties

    public List<MetaProperty> getProperties()
    Returns the available properties for this type.
    Specified by:
      `getProperties` in interface `MetaClass`
    Specified by:
      `getProperties` in interface `MetaObjectProtocol`
    Returns:
      a list of `MetaProperty` objects
    See Also:
      - `MetaProperty`

  - ### applyPropertyDescriptors

    protected void applyPropertyDescriptors(PropertyDescriptor[] propertyDescriptors)
    Turns JavaBeans property descriptors into Groovy meta properties.
    Parameters:
      `propertyDescriptors` - the descriptors to apply

  - ### addMetaBeanProperty

    public void addMetaBeanProperty(MetaBeanProperty mp)
    Adds a new MetaBeanProperty to this MetaClass. Must not be called after initialization (mirroring `addMetaMethod(groovy.lang.MetaMethod)`): the mutation bumps no version and fires no invalidation, so call-site caches would keep serving the metaclass's pre-change state. Runtime changes belong on `ExpandoMetaClass`, whose mutation window lifts the restriction.
    Specified by:
      `addMetaBeanProperty` in interface `MutableMetaClass`
    Parameters:
      `mp` - The MetaBeanProperty
    Throws:
      `RuntimeException` - if this metaclass is already initialized

  - ### setProperty

    public void setProperty(Class sender, Object object, String name, Object newValue, boolean useSuper, boolean fromInsideClass)
    Writes a property on the given receiver for the specified arguments. The sender is the class that is requesting the property from the object. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided.

    The useSuper and fromInsideClass help the runtime perform optimisations on the call to go directly to the super class if necessary

    Specified by:
      `setProperty` in interface `MetaClass`
    Parameters:
      `sender` - The java.lang.Class instance that is mutating the property
      `object` - The Object which the property is being set on
      `name` - The name of the property
      `newValue` - The new value of the property to set
      `useSuper` - Whether the call is to a super class property
      `fromInsideClass` - Whether the call was invoked from the inside or the outside of the class.

  - ### getAttribute

    public Object getAttribute(Class sender, Object object, String attribute, boolean useSuper)
    Retrieves the value of an attribute (field). This method is to support the Groovy runtime and not for general client API usage.
    Specified by:
      `getAttribute` in interface `MetaClass`
    Parameters:
      `sender` - The class of the object that requested the attribute
      `object` - The instance
      `attribute` - The name of the attribute
      `useSuper` - Whether to look-up on the super class or not
    Returns:
      The attribute value

  - ### getAttribute

    public Object getAttribute(Class sender, Object object, String attribute, boolean useSuper, boolean fromInsideClass)
    Retrieves the value of an attribute (field). This method is to support the Groovy runtime and not for general client API usage.
    Parameters:
      `sender` - The class of the object that requested the attribute
      `object` - The instance the attribute is to be retrieved from
      `attribute` - The name of the attribute
      `useSuper` - Whether to look-up on the super class or not
      `fromInsideClass` - Whether the call was invoked from the inside or the outside of the class.
    Returns:
      The attribute value

  - ### setAttribute

    public void setAttribute(Class sender, Object object, String attribute, Object newValue, boolean useSuper, boolean fromInsideClass)

    Sets an attribute on the given receiver for the specified arguments. The sender is the class that is setting the attribute from the object. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided.

    The isCallToSuper and fromInsideClass help the Groovy runtime perform optimisations on the call to go directly to the super class if necessary

    Specified by:
      `setAttribute` in interface `MetaClass`
    Parameters:
      `sender` - The java.lang.Class instance that is mutating the property
      `object` - The Object which the property is being set on
      `attribute` - The name of the attribute,
      `newValue` - The new value of the attribute to set
      `useSuper` - Whether the call is to a super class property
      `fromInsideClass` - Whether the call was invoked from the inside or the outside of the class

  - ### getClassNode

    public ClassNode getClassNode()
    Obtains a reference to the original AST for the MetaClass if it is available at runtime
    Specified by:
      `getClassNode` in interface `MetaClass`
    Returns:
      The original AST or null if it cannot be returned

  - ### toString

    public String toString()
    Returns a string representation of this metaclass
    Overrides:
      `toString` in class `Object`

  - ### addMetaMethod

    public void addMetaMethod(MetaMethod method)
    Adds a MetaMethod to this class. WARNING: this method will not do the necessary steps for multimethod logic and using this method doesn't mean, that a method added here is replacing another method from a parent class completely. These steps are usually done by initialize, which means if you need these steps, you have to add the method before running initialize the first time.
    Specified by:
      `addMetaMethod` in interface `MutableMetaClass`
    Parameters:
      `method` - The MetaMethod to add
    See Also:
      - `initialize()`

  - ### addMetaMethodToIndex

    protected void addMetaMethodToIndex(MetaMethod method, Map<String,MetaMethodIndex.Cache> cacheIndex)
    Adds a meta method to the supplied method index after standard-hook bookkeeping.
    Parameters:
      `method` - the method to index
      `cacheIndex` - the target index bucket

  - ### checkIfGroovyObjectMethod

    protected final void checkIfGroovyObjectMethod(MetaMethod metaMethod)
    Checks if the metaMethod is getProperty, setProperty, or invokeMethod.
    See Also:
      - `GroovyObject`

  - ### isInitialized

    protected boolean isInitialized()
    Indicates whether this meta class finished initialization.
    Returns:
      `true` once initialization completed

  - ### setInitialized

    protected void setInitialized(boolean initialized)
    Updates the initialization flag for this meta class.
    Parameters:
      `initialized` - the new initialization state

  - ### chooseMethod

    protected Object chooseMethod(String methodName, Object methodOrList, Class[] arguments) throws MethodSelectionException
    Chooses the correct method to use from a list of methods which match by name.
    Parameters:
      `methodOrList` - the possible methods to choose from
      `arguments` - the arguments
    Throws:
      `MethodSelectionException`

  - ### doChooseMostSpecificParams

    protected static Object doChooseMostSpecificParams(String theClassName, String name, List matchingMethods, Class[] arguments, boolean checkParameterCompatibility)
    Chooses the most specific overload among matching parameter type candidates.
    Parameters:
      `theClassName` - the receiver class name used in diagnostics
      `name` - the method name
      `matchingMethods` - the candidate methods
      `arguments` - the runtime argument types
      `checkParameterCompatibility` - whether candidates should be filtered for compatibility first
    Returns:
      the selected candidate, or `null` if none matches

  - ### createErrorMessageForAmbiguity

    protected static String createErrorMessageForAmbiguity(String theClassName, String name, Class[] arguments, LinkedList matches)
    Creates the diagnostic message for an ambiguous overload selection.
    Parameters:
      `theClassName` - the receiver class name
      `name` - the method name
      `arguments` - the runtime argument types
      `matches` - the ambiguous candidates
    Returns:
      the ambiguity message

  - ### handleMatches

    protected static long handleMatches(long matchesDistance, LinkedList matches, Object method, long dist)
    Updates the current best-match set using the supplied distance metric.
    Parameters:
      `matchesDistance` - the best distance seen so far
      `matches` - the current best candidates
      `method` - the candidate method
      `dist` - the candidate distance
    Returns:
      the updated best distance

  - ### initialize

    public void initialize()
    Complete the initialisation process. After this method is called no methods should be added to the metaclass. Invocation of methods or access to fields/properties is forbidden unless this method is called. This method should contain any initialisation code, taking a longer time to complete. An example is the creation of the Reflector. It is suggested to synchronize this method.
    Specified by:
      `initialize` in interface `MetaClass`

  - ### reinitialize

    protected void reinitialize()
    Rebuilds method, property and call-site state for this meta class.

  - ### getMethods

    public List<MetaMethod> getMethods()
    Retrieves the list of MetaMethods held by the class. This list does not include MetaMethods added by groovy.lang.ExpandoMetaClass.
    Specified by:
      `getMethods` in interface `MetaClass`
    Specified by:
      `getMethods` in interface `MetaObjectProtocol`
    Returns:
      A list of MetaMethods
    See Also:
      - `MetaMethod`

  - ### getMetaMethods

    public List<MetaMethod> getMetaMethods()
    Retrieves the list of MetaMethods held by this class. This list includes MetaMethods added by groovy.lang.ExpandoMetaClass.
    Specified by:
      `getMetaMethods` in interface `MetaClass`
    Returns:
      A list of MetaMethods

  - ### dropStaticMethodCache

    protected void dropStaticMethodCache(String name)
    Clears cached static method selections for the supplied method name.
    Parameters:
      `name` - the method name whose cache entries should be cleared

  - ### dropMethodCache

    protected void dropMethodCache(String name)
    Clears cached instance method selections for the supplied method name.
    Parameters:
      `name` - the method name whose cache entries should be cleared

  - ### getClassInfo

    public ClassInfo getClassInfo()
    Returns the ClassInfo for the contained Class
    Returns:
      The ClassInfo for the contained class.

  - ### getVersion

    public int getVersion()
    Returns version of the contained Class
    Returns:
      The version of the contained class.

  - ### incVersion

    public void incVersion()
    Increments version of the contained Class

  - ### getAdditionalMetaMethods

    public MetaMethod[] getAdditionalMetaMethods()
    Retrieves a list of additional MetaMethods held by this class
    Returns:
      A list of MetaMethods

  - ### findPropertyInClassHierarchy

    protected MetaBeanProperty findPropertyInClassHierarchy(String propertyName, CachedClass theClass)
    Searches the class hierarchy for a mutable meta-class bean property on the missing-property path. Linked miss sites re-enter this walk live (no SwitchPoint fan-out); see `IndyInvalidation`.
    Parameters:
      `propertyName` - the property name
      `theClass` - the class to start searching from
    Returns:
      the matching bean property, or `null` if none is found

  - ### findMixinMethod

    protected MetaMethod findMixinMethod(String methodName, Class[] arguments)
    Searches for a matching mixin method.
    Parameters:
      `methodName` - the method name
      `arguments` - the parameter types
    Returns:
      the matching mixin method, or `null` if none is found

  - ### findMethodInClassHierarchy

    protected static MetaMethod findMethodInClassHierarchy(Class instanceKlazz, String methodName, Class[] arguments, MetaClass metaClass)
    Searches a meta-class hierarchy for the most specific visible method on the missing-method path.

    For a starting `MetaClassImpl`, the walk opens only when some strong MetaClass in the receiver hierarchy is a modified `MutableMetaClass` (typically `ExpandoMetaClass`). This is how patterns such as `Object.metaClass.foo = …` / parent EMC methods become visible on subclass receivers without giving every subtype its own EMC.

    6.0 (GROOVY-12191): this walk is retained. Linked miss sites re-enter it live without SwitchPoint fan-out — see `IndyInvalidation`.

    Parameters:
      `instanceKlazz` - the runtime receiver class
      `methodName` - the method name
      `arguments` - the parameter types
      `metaClass` - the starting meta class
    Returns:
      the selected method, or `null` if none matches

  - ### findOwnMethod

    protected static MetaMethod findOwnMethod(Class instanceKlazz, String methodName, Class[] arguments, MetaClass metaClass, MetaMethod method)
    Chooses the best method declared directly on the supplied meta class.
    Parameters:
      `instanceKlazz` - the runtime receiver class
      `methodName` - the method name
      `arguments` - the parameter types
      `metaClass` - the meta class being inspected
      `method` - the current best method candidate
    Returns:
      the updated best method candidate

  - ### getSubclassMetaMethods

    protected Object getSubclassMetaMethods(String methodName)
    Returns subclass-scoped meta methods contributed by specialized meta classes.
    Parameters:
      `methodName` - the method name
    Returns:
      subclass methods for the name, or `null` if none are registered

  - ### getProperty

    public Object getProperty(Object object, String property)

    Retrieves a property on the given object for the specified arguments.

    Specified by:
      `getProperty` in interface `MetaObjectProtocol`
    Parameters:
      `object` - The Object which the property is being retrieved from
      `property` - The name of the property
    Returns:
      The properties value
    See Also:
      - `MetaClassImpl`

  - ### setProperty

    public void setProperty(Object object, String property, Object newValue)

    Sets a property on the given object for the specified arguments.

    Specified by:
      `setProperty` in interface `MetaObjectProtocol`
    Parameters:
      `object` - The Object which the property is being retrieved from
      `property` - The name of the property
      `newValue` - The new value
    See Also:
      - `MetaClassImpl`

  - ### getAttribute

    public Object getAttribute(Object object, String attribute)
    Retrieves the value of an attribute (field). This method is to support the Groovy runtime and not for general client API usage.
    Specified by:
      `getAttribute` in interface `MetaObjectProtocol`
    Parameters:
      `object` - The object to get the attribute from
      `attribute` - The name of the attribute
    Returns:
      The attribute value
    See Also:
      - `MetaClassImpl`

  - ### setAttribute

    public void setAttribute(Object object, String attribute, Object newValue)
    Sets the value of an attribute (field). This method is to support the Groovy runtime and not for general client API usage.
    Specified by:
      `setAttribute` in interface `MetaObjectProtocol`
    Parameters:
      `object` - The object to get the attribute from
      `attribute` - The name of the attribute
      `newValue` - The new value of the attribute
    See Also:
      - `MetaClassImpl`

  - ### pickMethod

    public MetaMethod pickMethod(String methodName, Class[] arguments)
    Selects a method by name and argument classes. This method does not search for an exact match, it searches for a compatible method. For this the method selection mechanism is used as provided by the implementation of this MetaClass. pickMethod may or may not be used during the method selection process when invoking a method. There is no warranty for that.
    Specified by:
      `pickMethod` in interface `MetaClass`
    Parameters:
      `methodName` - the name of the method to pick
      `arguments` - the method arguments
    Returns:
      a matching MetaMethod or null
    Throws:
      `GroovyRuntimeException` - if there is more than one matching method

  - ### hasCustomInvokeMethod

    public boolean hasCustomInvokeMethod()
    indicates is the metaclass method invocation for non-static methods is done through a custom invoker object.
    Returns:
      true - if the method invocation is not done by the metaclass itself

  - ### hasCustomStaticInvokeMethod

    public boolean hasCustomStaticInvokeMethod()
    indicates is the metaclass method invocation for static methods is done through a custom invoker object.
    Returns:
      true - if the method invocation is not done by the metaclass itself

  - ### clearInvocationCaches

    protected void clearInvocationCaches()
    remove all method call cache entries. This should be done if a method is added during runtime, but not by using a category.

  - ### isPermissivePropertyAccess

    public boolean isPermissivePropertyAccess()
    Indicates whether permissive property access semantics are enabled.
    Returns:
      `true` if missing getters may still resolve fields or map entries

  - ### setPermissivePropertyAccess

    public void setPermissivePropertyAccess(boolean permissivePropertyAccess)
    Enables or disables permissive property access semantics.
    Parameters:
      `permissivePropertyAccess` - the new permissive-property-access flag